Subject: Re: [PATCH v3 18/26] arm64: Introduce asm/vdso/processor.h

From: Catalin Marinas <[email-masked]>
Date: Mon, 16 Mar 2020 15:49:31 +0000

On Mon, Mar 16, 2020 at 03:33:30PM +0000, Vincenzo Frascino wrote:
> On 3/16/20 2:43 PM, Catalin Marinas wrote[...]
> >> To me does not seem optimized out. Which version of the compiler are you using?
> > 
> > I misread the #ifdef'ery in asm/processor.h. So with 4K pages,
> > TASK_SIZE_32 is (1UL<<32)-PAGE_SIZE. However, with 64K pages _and_
> > CONFIG_KUSER_HELPERS, TASK_SIZE_32 is 1UL<<32 and the check is removed
> > by the compiler.
> > 
> > With the 4K build, __vdso_clock_gettime starts as:
> > 
> > 00000194 <__vdso_clock_gettime>:
> >  194:   f511 5f80       cmn.w   r1, #4096       ; 0x1000
> >  198:   d214            bcs.n   1c4 <__vdso_clock_gettime+0x30>
> >  19a:   b5b0            push    {r4, r5, r7, lr}
> >  ...
> >  1c4:   f06f 000d       mvn.w   r0, #13
> >  1c8:   4770            bx      lr
> > 
> > With 64K pages:
> > 
> > 00000194 <__vdso_clock_gettime>:
> >  194:   b5b0            push    {r4, r5, r7, lr}
> >  ...
> >  1be:   bdb0            pop     {r4, r5, r7, pc}
> > 
> > I haven't tried but it's likely that the vdsotest fails with 64K pages
> > and compat enabled (requires EXPERT).
> 
> This makes more sense. Thanks for the clarification.
> 
> I agree on the behavior of 64K pages and I think as well that the
> "compatibility" issue is still there. However as you correctly stated in your
> first email arm32 never supported 16K or 64K pages, hence I think we should not
> be concerned about compatibility in this cases.

My point is that even with 4K pages it's not really compatibility. The
test uses UINTPTR_MAX but on arm32 it would also fail with 0xc0000000.
On arm64 compat, however, this value would pass just fine.

> To make it more explicit we could make COMPAT_VDSO on arm64 depend on
> ARM64_4K_PAGES. What do you think?

No, I don't see why we should add this limitation.

> >> Please find below the list of errors for clock_gettime (similar for the other):
> >>
> >> passing UINTPTR_MAX to clock_gettime (VDSO): terminated by unexpected signal 7
> >> clock-gettime-monotonic/abi: 1 failures/inconsistencies encountered
> > 
> > Ah, so it uses UINTPTR_MAX in the test. Fair enough but I don't think
> > the arm64 check is entirely useful. On arm32, the check was meant to
> > return -EFAULT for addresses beyond TASK_SIZE that may enter into the
> > kernel or module space. On arm64 compat, the kernel space is well above
> > the reach of the 32-bit code.
> > 
> > If you want to preserve some compatibility for this specific test, what
> > about checking for wrapping around 0, I think it would make more sense.
> > Something like:
> > 
> > 	if ((u32)ts > UINTPTR_MAX - sizeof(*ts) + 1)
> 
> Ok, sounds good to me. But it is something that this patch series inherited,
> hence I would prefer to send a separate patch that introduces what you are
> proposing and removes TASK_SIZE_32 from the headers. How does it sound?

I'd rather avoid moving TASK_SIZE_32 unnecessarily. Just add a
preparatory patch to your series for arm64 compat vdso and follow with
the rest without moving TASK_SIZE_32 around.

-- 
Catalin

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel